package com.servisoft.geolocalizador;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "com.servisoft.geolocalizador", "com.servisoft.geolocalizador.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, true))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "com.servisoft.geolocalizador", "com.servisoft.geolocalizador.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "com.servisoft.geolocalizador.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static String _apikey = "";
public anywheresoftware.b4a.objects.collections.List _placelist = null;
public anywheresoftware.b4a.objects.ListViewWrapper _listview1 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _et1 = null;
public static String[] _somearray = null;
public static double _latitude = 0;
public static double _longitude = 0;
public com.servisoft.geolocalizador.httputils2service _httputils2service = null;
public com.servisoft.geolocalizador.f _f = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 32;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 34;BA.debugLine="Activity.LoadLayout(\"Layout1\")";
mostCurrent._activity.LoadLayout("Layout1",mostCurrent.activityBA);
 //BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 42;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 44;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 38;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 40;BA.debugLine="End Sub";
return "";
}
public static String  _display_result() throws Exception{
String _direccion = "";
int _x = 0;
anywheresoftware.b4a.objects.collections.Map _tempmap = null;
anywheresoftware.b4a.keywords.StringBuilderWrapper _sb = null;
 //BA.debugLineNum = 155;BA.debugLine="Sub Display_Result";
 //BA.debugLineNum = 157;BA.debugLine="ListView1.Clear";
mostCurrent._listview1.Clear();
 //BA.debugLineNum = 158;BA.debugLine="Dim direccion As String";
_direccion = "";
 //BA.debugLineNum = 159;BA.debugLine="For x = 0 To PlaceList.Size - 1";
{
final int step3 = 1;
final int limit3 = (int) (mostCurrent._placelist.getSize()-1);
for (_x = (int) (0) ; (step3 > 0 && _x <= limit3) || (step3 < 0 && _x >= limit3); _x = ((int)(0 + _x + step3)) ) {
 //BA.debugLineNum = 160;BA.debugLine="Dim TempMap As Map = PlaceList.Get(x)";
_tempmap = new anywheresoftware.b4a.objects.collections.Map();
_tempmap.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(mostCurrent._placelist.Get(_x)));
 //BA.debugLineNum = 161;BA.debugLine="Dim SB As StringBuilder";
_sb = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
 //BA.debugLineNum = 162;BA.debugLine="SB.Initialize";
_sb.Initialize();
 //BA.debugLineNum = 163;BA.debugLine="SB.Append(\"\").Append(TempMap.Get(\"Name\"))";
_sb.Append("").Append(BA.ObjectToString(_tempmap.Get((Object)("Name"))));
 //BA.debugLineNum = 165;BA.debugLine="ListView1.TwoLinesAndBitmap.SecondLabel.TextSize";
mostCurrent._listview1.getTwoLinesAndBitmap().SecondLabel.setTextSize((float) (5));
 //BA.debugLineNum = 166;BA.debugLine="ListView1.TwoLinesAndBitmap.Label.TextSize = 12";
mostCurrent._listview1.getTwoLinesAndBitmap().Label.setTextSize((float) (12));
 //BA.debugLineNum = 167;BA.debugLine="ListView1.TwoLinesAndBitmap.ImageView.Top = 15di";
mostCurrent._listview1.getTwoLinesAndBitmap().ImageView.setTop(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (15)));
 //BA.debugLineNum = 168;BA.debugLine="ListView1.TwoLinesAndBitmap.ImageView.Width =";
mostCurrent._listview1.getTwoLinesAndBitmap().ImageView.setWidth(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (30)));
 //BA.debugLineNum = 169;BA.debugLine="ListView1.TwoLinesAndBitmap.ImageView.Height";
mostCurrent._listview1.getTwoLinesAndBitmap().ImageView.setHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (30)));
 //BA.debugLineNum = 170;BA.debugLine="ListView1.TwoLinesAndBitmap.ImageView.Gravity =";
mostCurrent._listview1.getTwoLinesAndBitmap().ImageView.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER_HORIZONTAL);
 //BA.debugLineNum = 173;BA.debugLine="direccion = SB.ToString";
_direccion = _sb.ToString();
 //BA.debugLineNum = 175;BA.debugLine="ListView1.AddTwoLinesAndBitmap(direccion,\"\",Load";
mostCurrent._listview1.AddTwoLinesAndBitmap(_direccion,"",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmapSample(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"maps-icon.png",anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (10)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (13))).getObject()));
 }
};
 //BA.debugLineNum = 177;BA.debugLine="ListView1.Visible = True";
mostCurrent._listview1.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 179;BA.debugLine="End Sub";
return "";
}
public static String  _et1_textchanged(String _old,String _new) throws Exception{
String _keyword = "";
 //BA.debugLineNum = 55;BA.debugLine="Sub Et1_TextChanged (Old As String, New As String)";
 //BA.debugLineNum = 56;BA.debugLine="Dim KeyWord As String = New.Trim";
_keyword = _new.trim();
 //BA.debugLineNum = 62;BA.debugLine="KeyWord = KeyWord.Replace(\" \", \"+\") 'Required to";
_keyword = _keyword.replace(" ","+");
 //BA.debugLineNum = 63;BA.debugLine="KeyWord = KeyWord.Replace(\"#\", \"\")";
_keyword = _keyword.replace("#","");
 //BA.debugLineNum = 64;BA.debugLine="Text_Search_Request(KeyWord, \"Prediccion\")";
_text_search_request(_keyword,"Prediccion");
 //BA.debugLineNum = 67;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 22;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 25;BA.debugLine="Dim PlaceList As List 'Request result list.";
mostCurrent._placelist = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 26;BA.debugLine="Private ListView1 As ListView";
mostCurrent._listview1 = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Private Et1 As EditText";
mostCurrent._et1 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Dim SomeArray(10) As String";
mostCurrent._somearray = new String[(int) (10)];
java.util.Arrays.fill(mostCurrent._somearray,"");
 //BA.debugLineNum = 29;BA.debugLine="Dim latitude, longitude As Double";
_latitude = 0;
_longitude = 0;
 //BA.debugLineNum = 30;BA.debugLine="End Sub";
return "";
}
public static String  _jobdone(com.servisoft.geolocalizador.httpjob _job) throws Exception{
 //BA.debugLineNum = 83;BA.debugLine="Sub JobDone (Job As HttpJob)";
 //BA.debugLineNum = 84;BA.debugLine="ProgressDialogHide";
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 //BA.debugLineNum = 85;BA.debugLine="Log(\"JobName = \" & Job.JobName & \", Success =";
anywheresoftware.b4a.keywords.Common.Log("JobName = "+_job._jobname+", Success = "+BA.ObjectToString(_job._success));
 //BA.debugLineNum = 86;BA.debugLine="If Job.Success = True Then";
if (_job._success==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 88;BA.debugLine="Select Job.JobName";
switch (BA.switchObjectToInt(_job._jobname,"Prediccion","Referencia")) {
case 0: {
 //BA.debugLineNum = 90;BA.debugLine="JsonTree(Job.getString, \"predictions\")";
_jsontree(_job._getstring(),"predictions");
 break; }
case 1: {
 //BA.debugLineNum = 92;BA.debugLine="JsonTree(Job.getString, \"result\")";
_jsontree(_job._getstring(),"result");
 break; }
}
;
 }else {
 //BA.debugLineNum = 95;BA.debugLine="Log(\"Error: \" & Job.ErrorMessage)";
anywheresoftware.b4a.keywords.Common.Log("Error: "+_job._errormessage);
 //BA.debugLineNum = 96;BA.debugLine="ToastMessageShow(\"Error: \" & Job.ErrorMess";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Error: "+_job._errormessage,anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 98;BA.debugLine="Job.Release";
_job._release();
 //BA.debugLineNum = 99;BA.debugLine="End Sub";
return "";
}
public static String  _jsontree(String _jobstring,String _json_val) throws Exception{
anywheresoftware.b4a.objects.collections.JSONParser _parser = null;
anywheresoftware.b4a.objects.collections.Map _root = null;
anywheresoftware.b4a.objects.collections.List _results = null;
int _num = 0;
anywheresoftware.b4a.objects.collections.Map _colresults = null;
anywheresoftware.b4a.objects.collections.Map _tempmap = null;
String _direccion = "";
String _referencia = "";
anywheresoftware.b4a.objects.collections.Map _result = null;
anywheresoftware.b4a.objects.collections.Map _geometry = null;
anywheresoftware.b4a.objects.collections.Map _location = null;
double _lng = 0;
double _lat = 0;
String _name = "";
 //BA.debugLineNum = 101;BA.debugLine="Sub JsonTree(JobString As String, json_val As Stri";
 //BA.debugLineNum = 103;BA.debugLine="Select json_val";
switch (BA.switchObjectToInt(_json_val,"predictions","result")) {
case 0: {
 //BA.debugLineNum = 107;BA.debugLine="PlaceList.Initialize";
mostCurrent._placelist.Initialize();
 //BA.debugLineNum = 108;BA.debugLine="Dim parser As JSONParser";
_parser = new anywheresoftware.b4a.objects.collections.JSONParser();
 //BA.debugLineNum = 109;BA.debugLine="parser.Initialize(JobString)";
_parser.Initialize(_jobstring);
 //BA.debugLineNum = 110;BA.debugLine="Dim root As Map = parser.NextObject";
_root = new anywheresoftware.b4a.objects.collections.Map();
_root = _parser.NextObject();
 //BA.debugLineNum = 111;BA.debugLine="Dim results As List = root.Get(json_val)";
_results = new anywheresoftware.b4a.objects.collections.List();
_results.setObject((java.util.List)(_root.Get((Object)(_json_val))));
 //BA.debugLineNum = 112;BA.debugLine="Dim num As Int";
_num = 0;
 //BA.debugLineNum = 114;BA.debugLine="For Each colresults As Map In results";
_colresults = new anywheresoftware.b4a.objects.collections.Map();
final anywheresoftware.b4a.BA.IterableList group63 = _results;
final int groupLen63 = group63.getSize();
for (int index63 = 0;index63 < groupLen63 ;index63++){
_colresults.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(group63.Get(index63)));
 //BA.debugLineNum = 115;BA.debugLine="Dim TempMap As Map : TempMap.Initialize";
_tempmap = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 115;BA.debugLine="Dim TempMap As Map : TempMap.Initialize";
_tempmap.Initialize();
 //BA.debugLineNum = 117;BA.debugLine="Dim Direccion As String = colresults.Get(\"des";
_direccion = BA.ObjectToString(_colresults.Get((Object)("description")));
 //BA.debugLineNum = 118;BA.debugLine="TempMap.Put(\"Name\", Direccion)";
_tempmap.Put((Object)("Name"),(Object)(_direccion));
 //BA.debugLineNum = 120;BA.debugLine="Dim Referencia As String = colresults.Get(\"re";
_referencia = BA.ObjectToString(_colresults.Get((Object)("reference")));
 //BA.debugLineNum = 121;BA.debugLine="TempMap.Put(\"Address\", Referencia)";
_tempmap.Put((Object)("Address"),(Object)(_referencia));
 //BA.debugLineNum = 123;BA.debugLine="SomeArray(num) = Referencia";
mostCurrent._somearray[_num] = _referencia;
 //BA.debugLineNum = 124;BA.debugLine="num = num + 1";
_num = (int) (_num+1);
 //BA.debugLineNum = 126;BA.debugLine="PlaceList.Add(TempMap)";
mostCurrent._placelist.Add((Object)(_tempmap.getObject()));
 }
;
 //BA.debugLineNum = 128;BA.debugLine="num = 0";
_num = (int) (0);
 //BA.debugLineNum = 129;BA.debugLine="Display_Result 'Display results to customlistvi";
_display_result();
 break; }
case 1: {
 //BA.debugLineNum = 133;BA.debugLine="Dim parser As JSONParser";
_parser = new anywheresoftware.b4a.objects.collections.JSONParser();
 //BA.debugLineNum = 134;BA.debugLine="parser.Initialize(JobString)";
_parser.Initialize(_jobstring);
 //BA.debugLineNum = 135;BA.debugLine="Dim root As Map = parser.NextObject";
_root = new anywheresoftware.b4a.objects.collections.Map();
_root = _parser.NextObject();
 //BA.debugLineNum = 136;BA.debugLine="Dim result As Map = root.Get(\"result\")";
_result = new anywheresoftware.b4a.objects.collections.Map();
_result.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(_root.Get((Object)("result"))));
 //BA.debugLineNum = 137;BA.debugLine="Dim geometry As Map = result.Get(\"geometry\")";
_geometry = new anywheresoftware.b4a.objects.collections.Map();
_geometry.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(_result.Get((Object)("geometry"))));
 //BA.debugLineNum = 138;BA.debugLine="Dim location As Map = geometry.Get(\"location\")";
_location = new anywheresoftware.b4a.objects.collections.Map();
_location.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(_geometry.Get((Object)("location"))));
 //BA.debugLineNum = 139;BA.debugLine="Dim lng As Double = location.Get(\"lng\")";
_lng = (double)(BA.ObjectToNumber(_location.Get((Object)("lng"))));
 //BA.debugLineNum = 140;BA.debugLine="Dim lat As Double = location.Get(\"lat\")";
_lat = (double)(BA.ObjectToNumber(_location.Get((Object)("lat"))));
 //BA.debugLineNum = 141;BA.debugLine="Dim name As String = result.Get(\"name\")";
_name = BA.ObjectToString(_result.Get((Object)("name")));
 //BA.debugLineNum = 143;BA.debugLine="latitude = lat";
_latitude = _lat;
 //BA.debugLineNum = 144;BA.debugLine="longitude = lng";
_longitude = _lng;
 //BA.debugLineNum = 146;BA.debugLine="Msgbox(\"Latitude: \" & latitude & CRLF & \"longitu";
anywheresoftware.b4a.keywords.Common.Msgbox("Latitude: "+BA.NumberToString(_latitude)+anywheresoftware.b4a.keywords.Common.CRLF+"longitude: "+BA.NumberToString(_longitude)+anywheresoftware.b4a.keywords.Common.CRLF+"Address: "+_name,"",mostCurrent.activityBA);
 //BA.debugLineNum = 147;BA.debugLine="ListView1.Visible = False";
mostCurrent._listview1.setVisible(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 148;BA.debugLine="ListView1.Clear";
mostCurrent._listview1.Clear();
 //BA.debugLineNum = 149;BA.debugLine="Et1.Text = \"\"";
mostCurrent._et1.setText((Object)(""));
 break; }
}
;
 //BA.debugLineNum = 153;BA.debugLine="End Sub";
return "";
}
public static String  _listview1_itemclick(int _position,Object _value) throws Exception{
String _referencia = "";
 //BA.debugLineNum = 46;BA.debugLine="Sub ListView1_ItemClick (Position As Int, Value As";
 //BA.debugLineNum = 48;BA.debugLine="Dim Referencia As String";
_referencia = "";
 //BA.debugLineNum = 49;BA.debugLine="Referencia = SomeArray(Position)";
_referencia = mostCurrent._somearray[_position];
 //BA.debugLineNum = 50;BA.debugLine="Text_Search_Request(Referencia, \"Referencia\")";
_text_search_request(_referencia,"Referencia");
 //BA.debugLineNum = 53;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
httputils2service._process_globals();
f._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 16;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="Dim ApiKey As String = \"AIzaSyCSGEMetgwKp44D0cj70";
_apikey = "AIzaSyCSGEMetgwKp44D0cj70Kf2qn8t9FFQSBQ";
 //BA.debugLineNum = 20;BA.debugLine="End Sub";
return "";
}
public static String  _text_search_request(String _keyword,String _variable) throws Exception{
com.servisoft.geolocalizador.httpjob _job = null;
 //BA.debugLineNum = 69;BA.debugLine="Sub Text_Search_Request(KeyWord As String, variabl";
 //BA.debugLineNum = 71;BA.debugLine="Dim job As HttpJob";
_job = new com.servisoft.geolocalizador.httpjob();
 //BA.debugLineNum = 72;BA.debugLine="job.Initialize(variable, Me)";
_job._initialize(processBA,_variable,main.getObject());
 //BA.debugLineNum = 74;BA.debugLine="Select variable";
switch (BA.switchObjectToInt(_variable,"Prediccion","Referencia")) {
case 0: {
 //BA.debugLineNum = 76;BA.debugLine="job.Download(\"https://maps.googleapis.com/maps/";
_job._download("https://maps.googleapis.com/maps/api/place/autocomplete/json?input="+_keyword+"&key="+_apikey);
 break; }
case 1: {
 //BA.debugLineNum = 78;BA.debugLine="job.Download(\"https://maps.googleapis.com/maps/";
_job._download("https://maps.googleapis.com/maps/api/place/details/json?reference="+_keyword+"&key="+_apikey);
 break; }
}
;
 //BA.debugLineNum = 81;BA.debugLine="End Sub";
return "";
}
}
